package io.voosh.api;

import com.amazonaws.services.dynamodbv2.datamodeling.*;
import io.voosh.config.TableNames;
import io.voosh.download.HttpHeader;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.select.Elements;

import javax.ws.rs.core.Response;
import java.util.ArrayList;
import java.util.List;

@DynamoDBTable(tableName = TableNames.RESOURCE)
public class Resource
{
    @DynamoDBAutoGeneratedKey
    @DynamoDBHashKey
    private String id;

    @DynamoDBIndexHashKey
    private String projectId;

    private String title;
    private String url;
    private String content;
    private String contentType;

    @DynamoDBIgnore
    private List<HttpHeader> headers;

    public String getId()
    {
        return id;
    }

    public void setId(String id)
    {
        this.id = id;
    }

    public String getProjectId()
    {
        return projectId;
    }

    public void setProjectId(String projectId)
    {
        this.projectId = projectId;
    }

    public String getTitle()
    {
        return title;
    }

    public void setTitle(String title)
    {
        this.title = title;
    }

    public String getUrl()
    {
        return url;
    }

    public void setUrl(String url)
    {
        this.url = url;
    }

    public String getContent()
    {
        return content;
    }

    public void setContent(String content)
    {
        this.content = content;
    }

    public List<HttpHeader> getHeaders()
    {
        return headers;
    }

    public void setHeaders(List<HttpHeader> headers)
    {
        this.headers = headers;
    }

    public String getContentType()
    {
        return contentType;
    }

    public void setContentType(String contentType)
    {
        this.contentType = contentType;
    }


    @Override
    public String toString()
    {
        return "Resource{" +
               "id='" + id + '\'' +
               ", projectId='" + projectId + '\'' +
               ", title='" + title + '\'' +
               ", url='" + url + '\'' +
               ", content='" + content + '\'' +
               ", contentType='" + contentType + '\'' +
               ", headers=" + headers +
               '}';
    }

    public static Resource fromResponse(String url, Response resp)
    {
        Resource res = new Resource();
        res.setUrl( url);
        res.setContent( resp.readEntity(String.class) );

        List<HttpHeader> headers = new ArrayList<>( resp.getStringHeaders().size() );
        for (String headerName: resp.getHeaders().keySet())
        {
            String normalizedName = headerName.trim().toLowerCase();
            if (normalizedName.equals("content-encoding"))
                continue; //Don't store encoding header as content is not going to be gzipped. Also don't provide etag

            String val = resp.getHeaderString( headerName );
            HttpHeader header = new HttpHeader();
            header.setName(headerName);
            header.setValue(val);
            headers.add(header);

            if (headerName.trim().toLowerCase().equals("content-type"))
            {
                if (val != null)
                    val = val.trim().toLowerCase();

                res.setContentType( val );
            }

            //if (res.contentType != null && res.contentType.toLowerCase().contains("/html"))
            //{
                //fixme fix potential dupe parsing
                //fixme refactor
                Document doc = Jsoup.parse( res.content);
                Elements titles = doc.select("title");
                String title = null;
                if (!titles.isEmpty())
                    title = titles.first().ownText();
                if (title == null || title.trim().isEmpty())
                    title = url;

                res.setTitle(title);
            //}
        }

        res.setHeaders( headers );

        return res;
    }
}
